// Slickworm
// Copyright (c) 2002-2004, Michel O'Brien.
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//
//  1. Redistributions of source code must retain the above copyright notice,
//     this list of conditions and the following disclaimer.
//  2. Redistributions in binary form must reproduce the above copyright notice,
//     this list of conditions and the following disclaimer in the documentation
//     and/or other materials provided with the distribution.
//  3. Neither the names of the copyright holders nor the names of its
//     contributors may be used to endorse or promote products derived from this
//     software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
// IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
// OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
// WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
// OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

#include <string.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include "settings.h"
#include "filenames.h"

Settings::Settings()
{
    screen_width = 1280;
    screen_height = 1024;
}

Settings::~Settings()
{

}

std::string Settings::GetSettingsFilename()
{
#if defined(WIN32)
    return data_dir() + "\\slickworm.0.4.0.settings";
#else
    return std::string(getenv("HOME")) + "/.slickworm.0.4.0.settings";
#endif
}

void Settings::Load()
{
    std::ifstream input_file;
    input_file.open(GetSettingsFilename().c_str());
    if (input_file.fail())
    {
        //std::cout << "Failed to open " << GetSettingsFilename() << ". Using default settings. " << std::endl;
    }

    input_file >> screen_width;
    input_file >> screen_height;
}

void Settings::Save()
{
    std::ofstream output_file;
    output_file.open(GetSettingsFilename().c_str());
    if (output_file.fail())
    {
        std::cout << "Failed to save " << GetSettingsFilename() << std::endl;
    }

    output_file << screen_width << " " << screen_height;

}






